import java.net.*;
import java.io.*;

public class MyTools {
	int HSIZE=5;
		
	public Socket connetti_server(String nodo) {
		try {
			Socket sock=new  Socket(nodo,6000);
			return sock;
			}
		catch(IOException e) {
			System.out.println(e);
			return null;
		}
	}//connetti_server

	public Socket connetti_server_rem(String nodo) {
		try {
			Socket sock=new  Socket(nodo,6001);
			return sock;
			}
		catch(IOException e) {
			System.out.println(e);
			return null;
		}
	}//connetti_server_rem

	public Socket connetti_cleaner(String nodo) {
		try {
			Socket sock=new  Socket(nodo,7000);
			return sock;
			}
		catch(IOException e) {
			System.out.println(e);
			return null;
		}
	}//connetti_cleaner
			
	public void disconnetti(Socket sock) {
		try {
			sock.close();
			}
		catch (IOException e) {
			System.out.println(e);
			}
	}//disconnetti

	public void scrivi(Socket sock,String msg) {
		try { //uso BufferedWriter che implementa la write di String
			BufferedWriter bw=new BufferedWriter(new OutputStreamWriter(sock.getOutputStream()));
			Integer lun=new Integer(msg.length());
  		   String header=new String(lun.toString());
		   for (int i=header.length();i<HSIZE;i++) {  //for
		   	header=header+"#";   				       //per riempire fino
				}												    //ad HSIZE
			bw.write(header,0,header.length());
			bw.write(msg,0,msg.length());
         bw.flush();    //rem di metterla, solo una dopo le due write!!!
			}		
  		catch(IOException e){		 
      	System.out.println(e);	
      	}			
 	}//scrivi
	
	public String leggi(Socket sock) {
		String msg;
		try { //uso BufferedReader che implementa la read di String
			BufferedReader br=new BufferedReader(new InputStreamReader(sock.getInputStream()));
   		char[] array=new char[HSIZE];
	   	int buf_size=sock.getReceiveBufferSize();
		   char[] buf=new char[buf_size];
//header e' ad esempio la stringa "3####" di 5 char
//devo isolare i char numerici in "quanti" poi dopo
//alcuni passaggi con how_many arrivo finalmente
//alla lunghezza del msg in arrivo con la II write
			br.read(array,0,HSIZE);                     //leggo l'header e lo
			String header=new String(array);            //converto in String
			int i=header.indexOf('#');
			String quanti=new String(header.substring(0,i));       //ho ad es quanti="9" per "amici.txt"
			Integer how_many=new Integer(Integer.parseInt(quanti));//trasformo quanti in Integer, poi int
			int da_leggere=br.read(buf,0,how_many.intValue()); 
			msg=new String(buf,0,da_leggere);
			return msg;
			}
		catch(IOException e){
      	System.out.println(e);
      	return("0");
      	}
	}//leggi

	public void fileToSock(String nome,Socket sock) {
		try {
			FileInputStream fin=new FileInputStream(nome);
			DataOutputStream bw=new DataOutputStream(sock.getOutputStream());
			for(;;) {
				byte[] buf=new byte[512];
				int letti=fin.read(buf);
				if (letti==-1) {
					bw.write('#');	//mark finale
					break;
					}
				bw.write(buf,0,letti);
				}
			bw.flush();
// prova a fare la close del buffer della socket!
			fin.close();
			}
		catch (IOException e) {
			System.out.println(e);
			}
	}//fileToSock
	
	public void sockToFile (Socket sock,String nome) {
		try {
			FileOutputStream fout=new FileOutputStream(nome);
			DataInputStream br=new DataInputStream(sock.getInputStream());
			for(;;) {
				byte[] buf=new byte[512];
				int letti=br.read(buf);
				if (buf[letti-1]=='#') {
					letti=letti-1;
					fout.write(buf,0,letti);
					break;
					}
				fout.write(buf,0,letti);
				}
// prova a fare la close del buffer della socket!
			fout.close();
			}
		catch (IOException e) {
			System.out.println(e);
			}
	}//sockToFile

	public void sockToSock (Socket source,Socket dest) {
		try {
			DataInputStream br=new DataInputStream(source.getInputStream());
			DataOutputStream bw=new DataOutputStream(dest.getOutputStream());
			byte[] buf=new byte[512];
			for (;;) {
				int letti=br.read(buf);
				if (letti==-1) break;
				bw.write(buf,0,letti);
				}
			}
		catch (IOException e) {
			System.out.println(e);
			}
	}	//sockToSock
		
	public String[] sockToArray(Socket sock) {
		int count=0;
		String[] array=new String[100];  //HP server max le 100 canzoni per data composiz
		try {			         				//HP tutti i titoli terminano con un '\n'
			DataInputStream br=new DataInputStream(sock.getInputStream());
			byte[] buf=new byte[512];
			int lung_assol=0; int lung_rel=0;
			for (;;) {
				int letti=br.read(buf);   			//leggo uno stream di titoli sul buffer
				for (lung_assol=0,lung_rel=0;lung_assol<letti;lung_assol++,lung_rel++) {
					if (buf[lung_assol]=='\n'){	//isolo un titolo nel buffer
						String str=new String(buf);
						array[count]=new String(str.substring(lung_assol-lung_rel,lung_assol+1));
						lung_rel=-1;               			//^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
						count++;										//N.B. nel substring ci va quel +1 finale!	
						}												//e' perche' il NEWLINE DEI  FILE e' DIVERSO
					}//for interno									//DA QUELLO CLASSICO, e conta 2 bytes, non 1!!
				if (buf[letti-1]=='#') break;
				}//for esterno
			array[count]="#"; //mark finale
// prova a fare la close del buffer della socket!
			}//try
		catch (IOException e) {
			System.out.println(e);
			}
		if (count>0) return array;
		else return null;
	}//sockToArray


	public int conta_new_line(String nome) {
		try {
			FileInputStream fin=new FileInputStream(nome);
			int count=0;
			int quanti=fin.available();
			for (int i=0;i<quanti;i++)
				if (fin.read()=='\n') count++;
			fin.close();
			return count;
			}
		catch (IOException e) {
			System.out.println(e);
			return 0;
			}
	}//conta_new_line
	
	public int conta_nStrings(String[] vet) {
		for (int i=0;i<100;i++)
			if (vet[i].compareTo("#")==0)
				return i;
		return 0; //se arriva qui non l'ha trovato!
	}//conta_nStrings
	
	
	public void sockToScreen(Socket sock) {
		int count=0;
		try {
			DataInputStream br=new DataInputStream(sock.getInputStream());
			byte[] buf=new byte[512];
			int lung_assol=0; int lung_rel=0;
			for (;;) {
				int letti=br.read(buf);   				//leggo uno stream di titoli sul buffer
				for (lung_assol=0,lung_rel=0;lung_assol<letti;lung_assol++,lung_rel++) {
					if (buf[lung_assol]=='\n'){ 		//isolo un titolo nel buffer
						String buf_string=new String(buf);
						String titolo=new String(buf_string.substring(lung_assol-lung_rel,lung_assol+1));
						System.out.print(titolo);			//^^^^^^^^^^^ guarda il metodo sockToArray!!!
						lung_rel=-1;
						count++;	
						}
					}//for interno
				if (buf[letti-1]=='#') break;
				}//for esterno
// prova a fare la close del buffer della socket!
			System.out.println(count+" songs available");
			}//try
		catch (IOException e) {
			System.out.println(e);
			}
	}//sockToScreen

	public void arrayToSock(String[] array,Socket sock) {
		try {
			DataOutputStream bw=new DataOutputStream(sock.getOutputStream());
			int n_songs=conta_nStrings(array);
			for (int i=0;i<n_songs;i++) {
				bw.write(array[i].getBytes());
				}
			bw.write('#'); //mark per dire FINITO
			bw.flush();
			}
		catch (IOException e) {
			System.out.println(e);
			}
	}//arrayToSock

	public boolean xisPresentInArray(String titolo,String[] array) {
		boolean ispresent=false;
		int n_songs=conta_nStrings(array);
		for (int i=0;i<n_songs;i++)
			if ( array[i].equals(titolo) || (array[i].indexOf(titolo)==0 && array[i].length()==titolo.length()+2) ) {
				ispresent=true;
				break;
				}
		return ispresent;
	}//xisPresentInArray
		
	public String[] listaUnici(String[] lista_1,String[] lista_2) {
		String[] lista_tot=new String[300];
		int i=0; int j=0; int k=0;
		for(;;) {
			if (lista_1[i].compareTo(lista_2[j])<0)
				lista_tot[k++]=new String(lista_1[i++]);
				else if (lista_1[i].compareTo(lista_2[j])>0)
					lista_tot[k++]=new String(lista_2[j++]);
					else { // il caso lista_1[i]==lista_2[j]
						lista_tot[k++]=new String(lista_2[j++]);
						i++;
						}
			if (lista_1[i].equals("#") || lista_2[j].equals("#"))
				break;
			}//for
		while (!lista_1[i].equals("#")) //se entra qui era finita lista_2
			lista_tot[k++]=new String(lista_1[i++]);
		while (!lista_2[j].equals("#")) //se entra qui era finita lista_1
			lista_tot[k++]=new String(lista_2[j++]);
		//se erano finite entrambe non entra in nessuno dei 2 while
		lista_tot[k]=new String("#"); //mark finale
		return lista_tot;
	}//listaUnici

}//class MyTools